<script lang="ts" setup>
import { decisionSteps } from '~/data/steps/decisionData';
import { Answer, WarningMessage } from '~/models/stepper';
import { Licence, Licences } from '~/models/licence';

const { getItems } = useDirectusItems();
const route = useRoute();
const router = useRouter();

const currStepIndex = ref(Number(route.query.currStepIndex) | 0);
const currDecisionIndex = ref(Number(route.query.currDecisionIndex) | 0);

const showWarning = ref(false);
const all = ref(false);
const warning = ref<WarningMessage>({ title: '', text: '' });
const selectedLicence = ref<Licence | undefined>();

const licences = ref<Licences>([]);
const licencesPerm = ref<Record<string, string>[]>([]);
const licencesCopy = ref<Record<string, string>[]>([]);

const currDecision = computed(() => {
  return decisionSteps[currDecisionIndex.value];
});

watch(route, () => {
  currStepIndex.value = Number(route.query.currStepIndex);
  currDecisionIndex.value = Number(route.query.currDecisionIndex);
});

const filterlicencesByType = (licencesAll: Licences, type: string) => {
  return licencesAll.reduce<Record<string, string>[]>((acc, obj) => {
    return obj.type.includes(type)
      ? [
          ...acc,
          {
            name: obj.name,
            link: 'licence-libre/le-point-sur-les-licences-libres/' + obj.slug,
          },
        ]
      : [...acc];
  }, []);
};

const startStepper = () => {
  currStepIndex.value = 1;
  populateQuery();
};

const nextStep = () => {
  currStepIndex.value++;
};

const nextAnswer = async (answer: Answer) => {
  if (answer.last) {
    nextStep();
    licences.value = [];
    licencesPerm.value = [];
    licencesCopy.value = [];
    all.value = false;
    if (answer.solutions.includes('all')) {
      try {
        const licencesAll = await getItems<Licences>({
          collection: 'Licences',
          params: {
            fields: ['slug', 'name', 'summary', 'type', 'origin', 'purpose', 'pros', 'cons', 'projet_name', 'projet_link', 'projet_img'],
          },
        });
        licencesPerm.value = filterlicencesByType(licencesAll, 'Permissive');
        licencesCopy.value = filterlicencesByType(licencesAll, 'Copyleft');
        all.value = true;
      } catch (e) {}
    } else {
      try {
        licences.value = await getItems<Licences>({
          collection: 'Licences',
          params: {
            filter: { slug: { _in: answer.solutions } },
            fields: ['slug', 'name', 'summary', 'type', 'origin', 'purpose', 'pros', 'cons', 'projet_name', 'projet_link', 'projet_img'],
          },
        });
      } catch (e) {}
    }
  } else {
    if (answer.next) {
      currDecisionIndex.value = answer.next;
    }
  }
  if (answer.warning) {
    showWarning.value = true;
    warning.value.title = answer.warning.title;
    warning.value.text = answer.warning.text;
  }
  populateQuery();
};

const prevStep = (): void => {
  if (currStepIndex.value === 1) {
    if (currDecision.value.prev !== undefined) {
      currDecisionIndex.value = currDecision.value.prev;
    }
  } else {
    currStepIndex.value--;
  }
  populateQuery();
};

const populateQuery = () => {
  router.push({
    path: route.fullPath,
    query: {
      currStepIndex: currStepIndex.value || 0,
      currDecisionIndex: currDecisionIndex.value || 0,
    },
  });
};

const unShow = () => (showWarning.value = false);
</script>

<template>
  <div v-if="currStepIndex === 1" class="step1 anct-bg-blue">
    <div class="fr-container decision">
      <div class="fr-grid-row">
        <StepHeader :prev="currDecision.prev" :curr-step-index="currStepIndex" :curr-index="currDecisionIndex" @prev-step="prevStep" />
      </div>
      <h2 class="decision_question fr-h2 fr-pt-2w anct-text-center">
        {{ currDecision.question }}
      </h2>
      <div v-if="currDecision.info" class="fr-grid-row fr-grid-row--center anct-text-center">
        <p class="fr-col-8">{{ currDecision.info }}</p>
      </div>
      <div class="decision_answers fr-grid-row fr-grid-row--gutters fr-grid-row--center fr-pt-2w fr-pb-8w">
        <template v-for="(answer, index) in currDecision.answers" :key="`answer--${index}`">
          <Step :img-src="answer.imgSrc" :title="answer.label" :text="answer.text" @next-step="nextAnswer(answer)" />
        </template>
        <Warning :title="warning.title" :text="warning.text" :show="showWarning" @un-show="unShow" />
      </div>
    </div>
  </div>
  <div v-else-if="currStepIndex === 2 && all" class="step2">
    <div class="fr-container">
      <div class="fr-grid-row">
        <StepHeader :prev="currDecision.prev" :curr-step-index="currStepIndex" :curr-index="currDecisionIndex" @prev-step="prevStep" />
      </div>
      <h1 class="fr-h1 fr-pt-6w fr-pb-2w anct-text-center">
        Placez votre projet sous la même licence <br />
        que le composant principal que vous réutilisez
      </h1>
      <div class="fr-grid-row fr-grid-row--center anct-text-center">
        <p class="fr-col-10">
          Pour les projets "hybrides", veillez à ce qu'une licence soit associée à toutes les ressources que vous diffusez.
          <br />La <span class="anct-text-blue">Licence Ouverte 2.0</span> est préconisée par principe pour toutes ces ressources, sauf pour
          les logiciels et bases de données. Demandez à vos développeurs quel est selon eux le composant principal du projet
        </p>
      </div>
      <div class="licences-list fr-mb-11w anct-box-shadow">
        <div class="fr-pt-8w fr-pb-8w fr-pl-10w fr-pr-10w fr-grid-row anct-bg-white">
          <div class="fr-col-lg-6">
            <div class="fr-h2 fr-pb-2w">Licences appelées permissives</div>

            <template v-for="(licence, index) in licencesPerm" :key="`licence--${index}`">
              <div class="fr-pb-2w">
                <nuxt-link class="fr-link" :to="licence.link">{{ licence.name }}</nuxt-link>
                <br /><br />
              </div>
            </template>
          </div>
          <div class="fr-col-lg-6">
            <div class="fr-h2 fr-pb-2w">Licences appelées “partage à l’identique” ou “copyleft”</div>
            <template v-for="(licence, index) in licencesCopy" :key="`licence--${index}`">
              <div class="fr-pb-2w">
                <nuxt-link class="fr-link" :to="licence.link">{{ licence.name }}</nuxt-link>
                <br /><br />
              </div>
            </template>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div v-else-if="currStepIndex === 2" class="step2">
    <div v-if="licences.length" class="fr-container">
      <div class="fr-grid-row">
        <StepHeader :prev="currDecision.prev" :curr-step-index="currStepIndex" :curr-index="currDecisionIndex" @prev-step="prevStep" />
      </div>
      <div v-if="licences.length === 1" class="anct-text-center">
        <h1 class="fr-h1 fr-pt-6w fr-pb-6w">
          La licence la plus adaptée à votre situation <br /><span class="fr-text--regular">serait...</span>
        </h1>
      </div>
      <h2 v-else class="fr-h2 fr-pt-6w fr-pb-6w anct-text-center">{{ licences.length }} licences seraient adaptées à votre situation</h2>
      <template v-for="(licence, index) in licences" :key="`licence--${index}`">
        <div class="fr-pb-9w">
          <LicenceItem
            :name="licence.name"
            :slug="licence.slug"
            :summary="licence.summary"
            :pros="licence.pros"
            :cons="licence.cons"
            :type="licence.type"
            :origin="licence.origin"
            :purpose="licence.purpose"
            :projet-name="licence.projet_name"
            :projet-link="licence.projet_link"
            :projet-img="licence.projet_img"
          />
        </div>
      </template>
    </div>
    <div v-else class="fr-container">
      <div class="fr-grid-row">
        <StepHeader :prev="currDecision.prev" :curr-step-index="currStepIndex" :curr-index="currDecisionIndex" @prev-step="prevStep" />
      </div>
      <LicenceItem />
    </div>
  </div>
  <div v-else class="step1 anct-bg-blue">
    <div class="fr-container fr-grid-row fr-grid-row--center anct-text-center">
      <h1 class="fr-h1 fr-pt-6w">Trouvez en quelques minutes la licence adaptée à votre projet</h1>
      <div class="fr-col-9">
        <p class="">
          On doit bien admettre que ce n’est pas facile de s’y retrouver parmi la multiplicité des licences libres, leurs noms obscurs et
          les très nombreuses sources d’information.<br /><br />
          C’est pourquoi nous avons conçu un outil simple et rapide pour vous aider à faire un choix éclairé sur la licence libre la plus
          adaptée à votre projet selon votre situation.
        </p>
        <div class="fr-pb-5w anct-text-blue"><VIcon name="md-timer" /><span> Entre 3 et 8 min </span></div>
        <DsfrButton class="fr-mb-5w" label="Je renseigne mes informations" @click="startStepper" />
        <div class="timer__img">
          <img src="/img/timer.svg" alt="" />
        </div>
      </div>
    </div>
  </div>
</template>
<style lang="scss">
.step1 {
  padding-bottom: 3px;
}
.timer__img img {
  vertical-align: bottom;
}
.licence {
  min-height: 756px;
  .licence-pro__item,
  .licence-con__item {
    display: flex;
  }
  ul {
    list-style-type: none;
  }
}
.decision {
  .decision_answers {
    gap: 24px;
  }
}
.btn-prev {
  display: flex;
  justify-content: center;
  align-items: center;
  button {
    color: #161616;
    fill: currentColor;
    svg path {
      fill: #161616;
    }
  }
}

.step2 {
  background-color: #f5f5fe;
  background: linear-gradient(to top, white 40%, #f5f5fe 40%, #f5f5fe 100%);
}

.fr-link {
  cursor: pointer;
}
@media screen and (max-width: 999px) {
  .decision {
    .decision_answers {
      gap: 14px;
      padding: 0 !important;
    }
  }
  .type_cards {
    grid-template-columns: 1fr;
    .fr-card {
      height: 300px;
    }
  }
}
</style>
